(* Reduction definition *)

Require Import ssreflect ssrfun ssrbool eqtype ssrnat seq choice fintype.
Require Import finfun tuple ssralg matrix mxalgebra bigop.


Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Section reduction_definition.

Local Open Scope ring_scope.

(* Reduction with just two non-null differentials *)

Record reduction :=
{ K  : fieldType;
 c0 : nat;
 c1 : nat;
 d0 : nat;
 d1 : nat; 
 D1 : 'M[K]_(c1,c0);
 D1' : 'M[K]_(d1,d0);
 F0 : 'M[K]_(c0,d0);
 F1 : 'M[K]_(c1,d1);
 G0 : 'M[K]_(d0,c0); 
 G1 : 'M[K]_(d1,c1);
 H0 : 'M[K]_(c0,c1); 
 F0_morph : (D1 *m F0) = (F1 *m D1');
 G0_morph : (D1' *m G0) = (G1 *m D1);
 ax1_0 : (G0 *m F0) = 1%:M;
 ax1_1 : (G1 *m F1) = 1%:M;
 ax2_0 : (F0 *m G0) + (H0 *m D1) = 1%:M;
 ax2_1 : (F1 *m G1) + (D1 *m H0) = 1%:M;
 ax3_0 : (H0 *m F1) = 0;
 ax4_0 : (G0 *m H0) = 0
}.

End reduction_definition.